// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// 
// FAUVART Sbastien	<seb.fauvart@free.fr>
// Mon May 19 12:57:45 2003

#ifndef __APPLICATION_H__
#define __APPLICATION_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <iostream.h>
#include <SDL/SDL.h>
#include <SDL/SDL_opengl.h>

#include "init_display.h"
#include "display.h"
#include "texture.h"
#include "event.h"
#include "game.h"
#include "cgui.h"

#include "variables.h"

class CApplication
{
 public:

  CApplication();
  ~CApplication();

  int Go();
  void MainLoop(void);
  void RenderScene();
  void Quit();

  int window_width, window_height;
  
 private:
  void Init_Application();
  int RetrieveObjectID(int x, int y);
  
};

#endif

