// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// 
// FAUVART Sbastien	<seb.fauvart@free.fr>
// Mon May 19 12:57:45 2003


#include "../include/cgui.h"
#include "../include/cfont.h"

static CFont      *Gui_Font = NULL;

int Flag_NumeroDuMenuAAfficher, Flag_InfoDuJeuAAfficher;

CGui::CGui()
{
  
    Gui_Font = new CFont;
    Flag_NumeroDuMenuAAfficher = gui_menu_principal;
	Flag_InfoDuJeuAAfficher	   = gui_info_findujeu;
	
}

void CGui::DrawMenu()
{
  
  glPushMatrix();
  glScalef(0.1f, 0.1f, 1.0f);
  glRotatef(-2.25, 1.0f, 0.0f, 0.0f);
  glTranslatef(-8.0f, 30.0f, 8.0f);
  
	if(Flag_NumeroDuMenuAAfficher == gui_menu_principal)
		Draw_Menu_Principal();
	
	else if(Flag_NumeroDuMenuAAfficher == gui_menu_nouvelle_partie)
		Draw_Menu_Nouvelle_Partie();

	else if(Flag_NumeroDuMenuAAfficher == gui_menu_options)
		Draw_Menu_Options();
	
	else if(Flag_NumeroDuMenuAAfficher == gui_menu_informations)
		Draw_Menu_Informations();

	else if(Flag_NumeroDuMenuAAfficher == gui_menu_quitter)
		Draw_Menu_Quitter();

  glPopMatrix();
  
}


void CGui::Draw_Menu_Principal()
{
	
	  Gui_Font->Draw_Contour(-1, 1, 18, -5);

	  glLoadName(GUI_MENU_NOUVELLE_PARTIE);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_NOUVELLE_PARTIE)
            Gui_Font->DrawText( 0, 0, chars_texture,  " NOUVELLE PARTIE ");
        else
            Gui_Font->DrawText( 0, 0, chars2_texture, " NOUVELLE PARTIE ");
      glEnd();

      glLoadName(GUI_MENU_OPTIONS);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_OPTIONS)
            Gui_Font->DrawText( 0, -1, chars_texture,  "     OPTIONS     ");
        else
            Gui_Font->DrawText( 0, -1, chars2_texture, "     OPTIONS     ");
      glEnd();
      
      glLoadName(GUI_MENU_INFORMATIONS);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_INFORMATIONS)
            Gui_Font->DrawText( 0, -2, chars_texture,  "   INFORMATION   ");
        else
            Gui_Font->DrawText( 0, -2, chars2_texture, "   INFORMATION   ");
      glEnd();

      glLoadName(GUI_MENU_REVENIR);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_REVENIR)
            Gui_Font->DrawText( 0, -3, chars_texture,  "     REVENIR     ");
        else
            Gui_Font->DrawText( 0, -3, chars2_texture, "     REVENIR     ");
      glEnd();

      glLoadName(GUI_MENU_QUITTER);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_QUITTER)
            Gui_Font->DrawText( 0, -4, chars_texture,  "     QUITTER     ");
        else
            Gui_Font->DrawText( 0, -4, chars2_texture, "     QUITTER     ");
      glEnd();
	
}

void CGui::Draw_Menu_Options()
{

	  glLoadName(GUI_MENU_OPTIONS_NIVEAU);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_OPTIONS_NIVEAU)
            Gui_Font->DrawText( -4, 1, chars_texture,  " NIVEAU DE DIFFICULTE :  ");
        else
            Gui_Font->DrawText( -4, 1, chars2_texture, " NIVEAU DE DIFFICULTE :  ");
      glEnd();

	  glLoadName(GUI_MENU_OPTIONS_AIDE);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_OPTIONS_AIDE)
            Gui_Font->DrawText( -4, 0, chars_texture,  "          AIDE           ");
        else
            Gui_Font->DrawText( -4, 0, chars2_texture, "          AIDE           ");
      glEnd();

	  glLoadName(GUI_MENU_OPTIONS_SON);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_OPTIONS_SON)
            Gui_Font->DrawText( -4, -1, chars_texture,  "        AVEC SON         ");
        else
            Gui_Font->DrawText( -4, -1, chars2_texture, "        AVEC SON         ");
      glEnd();

	  glLoadName(GUI_MENU_OPTIONS_STYLE);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_OPTIONS_STYLE)
            Gui_Font->DrawText( -4, -2, chars_texture,  "    STYLE : CLASSIQUE    ");
        else
            Gui_Font->DrawText( -4, -2, chars2_texture, "    STYLE : CLASSIQUE    ");
      glEnd();

	  glLoadName(GUI_MENU_OPTIONS_LANGUE);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_OPTIONS_LANGUE)
            Gui_Font->DrawText( -4, -3, chars_texture,  "    LANGUE : FRANCAIS    ");
        else
            Gui_Font->DrawText( -4, -3, chars2_texture, "    LANGUE : FRANCAIS    ");
      glEnd();

	  glLoadName(GUI_MENU_OPTIONS_REVENIR);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_OPTIONS_REVENIR)
            Gui_Font->DrawText( -4, -4, chars_texture,  "         REVENIR         ");
        else
            Gui_Font->DrawText( -4, -4, chars2_texture, "         REVENIR         ");
      glEnd();

	Gui_Font->Draw_Contour(-5, 2.5f, 22, -5);

}

void CGui::Draw_Menu_Nouvelle_Partie()
{
	
	Gui_Font->Draw_Contour(-6, 1.5f, 22, -3);

	glLoadName(GUI_MENU_NOUVELLE_PARTIE_VSCPU);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_NOUVELLE_PARTIE_VSCPU)
            Gui_Font->DrawText( -5, 0, chars_texture,  "    JOUEUR 1 CONTRE CPU   ");
        else
            Gui_Font->DrawText( -5, 0, chars2_texture, "    JOUEUR 1 CONTRE CPU   ");
      glEnd();

	glLoadName(GUI_MENU_NOUVELLE_PARTIE_VSJOUEUR2);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_NOUVELLE_PARTIE_VSJOUEUR2)
            Gui_Font->DrawText( -5, -1, chars_texture,  " JOUEUR 1 CONTRE JOUEUR 2 ");
        else
            Gui_Font->DrawText( -5, -1, chars2_texture, " JOUEUR 1 CONTRE JOUEUR 2 ");
      glEnd();

	glLoadName(GUI_MENU_NOUVELLE_PARTIE_RESEAU);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_NOUVELLE_PARTIE_RESEAU)
            Gui_Font->DrawText( -5, -2, chars_texture,  "          RESEAU          ");
        else
            Gui_Font->DrawText( -5, -2, chars2_texture, "          RESEAU          ");
      glEnd();

}

void CGui::Draw_Menu_Quitter()
{
	
	Gui_Font->Draw_Contour(-1, 0.5f, 18, -3);

    Gui_Font->DrawText( 0, -1, chars_texture,  " ETES VOUS SUR ? ");

	glLoadName(GUI_MENU_QUITTER_OK);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_QUITTER_OK)
            Gui_Font->DrawText( 0, -2, chars_texture,  "   OUI  ");
        else
            Gui_Font->DrawText( 0, -2, chars2_texture, "   OUI  ");
      glEnd();

	glLoadName(GUI_MENU_QUITTER_ANNULER);
      glBegin(GL_LINES);  glEnd();
        if(ObjectID == GUI_MENU_QUITTER_ANNULER)
            Gui_Font->DrawText( 8, -2, chars_texture,  "   NON   ");
        else
            Gui_Font->DrawText( 8, -2, chars2_texture, "   NON   ");
      glEnd();

}

void CGui::Draw_Menu_Informations()
{
	
}

void CGui::DrawInfo()
{

	if(Flag_InfoDuJeuAAfficher == gui_info_findujeu)
	{
		
	}

	if(Flag_InfoDuJeuAAfficher == gui_info_passetour)
	{
		
	}

}

CGui::~CGui()
{

    delete (Gui_Font);
    
}
