// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// 
// FAUVART Sbastien	<seb.fauvart@free.fr>
// Mon May 19 12:57:45 2003


#include "../include/event.h"
#include "../include/variables.h"

CEvent::CEvent()
{
  
  tmpupdown = 0;
  
}

void CEvent::KeyPressed(SDL_keysym *keysym)
{
    switch(keysym -> sym)
    {
        case SDLK_ESCAPE :
            Flag_Draw_Menu++;
            if(Flag_Draw_Menu > 1)
              Flag_Draw_Menu = 0;
              //menu_a_afficher = 1;
            break;

        case SDLK_F1 :
          if(SDL_WM_ToggleFullScreen(MainWindow) == 0)
          {
            cerr << "Failed to Toggle Fullscreen mode : " << SDL_GetError() << endl;
              
            SDL_Quit();
          }
            break;

/*        case SDLK_a :
            debug_x += 1.0f;
            cout << debug_x << " " << debug_y << " " << debug_z << endl;
            break;

        case SDLK_z :
            debug_y += 1.0f;
            cout << debug_x << " " << debug_y << " " << debug_z << endl;
            break;

        case SDLK_e :
            debug_z += 0.1f;
            cout << debug_x << " " << debug_y << " " << debug_z << endl;
            break;

        case SDLK_q :
            debug_x -= 1.0f;
            cout << debug_x << " " << debug_y << " " << debug_z << endl;
            break;

        case SDLK_s :
            debug_y -= 1.0f;
            cout << debug_x << " " << debug_y << " " << debug_z << endl;
            break;

        case SDLK_d :
            debug_z -= 0.1f;
            cout << debug_x << " " << debug_y << " " << debug_z << endl;
            break;*/

        default:
            break;
    }
}

void CEvent::MouseButtonRightDown(CGame *Event_Game)
{

    if((Flag_Draw_Menu == 0) && (Flag_Draw_Info == 0))
    {
        tmpupdown = 1;
    }

}

void CEvent::MouseButtonLeftDown(CGame *Event_Game)
{
    if((Flag_Draw_Menu == 0) && (Flag_Draw_Info == 0))
    {

      int possible_capture;
      
      possible_capture = Event_Game->Game_validmove(ObjectID, Event_Game->aquiletour, 1);
      
        if(possible_capture != 0)
        {
            if(Event_Game->aquiletour == PLAYER_1)
                        Event_Game->aquiletour = PLAYER_2;
            else
                        Event_Game->aquiletour = PLAYER_1;

            Event_Game->Game_calculate_score();
        }
        
    }

    if((Flag_Draw_Menu == 1) && (Flag_Draw_Info == 0))
    {
    
    }

    if((Flag_Draw_Menu == 0) && (Flag_Draw_Info == 1))
    {
    
    }
}

void CEvent::MouseButtonRightUp(CGame *Event_Game)
{

    if((Flag_Draw_Menu == 0) && (Flag_Draw_Info == 0))
    {
        tmpupdown = 0;
    }

}

void CEvent::MouseButtonLeftUp(CGame *Event_Game)
{

	if((Flag_Draw_Menu == 1))
	{
		switch (ObjectID)
		{
			case GUI_MENU_NOUVELLE_PARTIE:
				Flag_NumeroDuMenuAAfficher = gui_menu_nouvelle_partie;
				break;
			case GUI_MENU_CHARGER:
				break;
			case GUI_MENU_SAUVEGARDER:
				break;
			case GUI_MENU_OPTIONS:
				Flag_NumeroDuMenuAAfficher = gui_menu_options;
				break;
			case GUI_MENU_INFORMATIONS:
				Flag_NumeroDuMenuAAfficher = gui_menu_informations;
				break;
			case GUI_MENU_REVENIR:
				Flag_NumeroDuMenuAAfficher = gui_menu_principal;
				Flag_Draw_Menu = 0;
				break;
			case GUI_MENU_QUITTER:
				Flag_NumeroDuMenuAAfficher = gui_menu_quitter;
				break;

			case GUI_MENU_OPTIONS_NIVEAU:
				Flag_Difficulte++; 
				if(Flag_Difficulte == 4)
					Flag_Difficulte = 1;
				break;
			case GUI_MENU_OPTIONS_AIDE:
				if(Flag_Aide == 1)
					Flag_Aide = 2;
				else
					Flag_Aide = 1;
				break;
			case GUI_MENU_OPTIONS_SON:
				if(Flag_Son == 1)
					Flag_Son = 2;
				else
					Flag_Son = 1;
				break;
			case GUI_MENU_OPTIONS_STYLE:
				if(Flag_Style == 1)
					Flag_Style = 2;
				else
					Flag_Style = 1;
				break;
			case GUI_MENU_OPTIONS_LANGUE:
				if(Flag_Langue == 1)
					Flag_Langue = 2;
				else
					Flag_Langue = 1;
				break;
			case GUI_MENU_OPTIONS_REVENIR:
				Flag_NumeroDuMenuAAfficher = gui_menu_principal;
				break;
			
			case GUI_MENU_NOUVELLE_PARTIE_VSCPU:
				FlagModeDuJeu = MODE_VSCPU;
				Flag_NumeroDuMenuAAfficher = gui_menu_principal;
				Flag_Draw_Menu = 0;
				break;
			case GUI_MENU_NOUVELLE_PARTIE_VSJOUEUR2:
				FlagModeDuJeu = MODE_VSJOUEUR2;
				Flag_NumeroDuMenuAAfficher = gui_menu_principal;
				Flag_Draw_Menu = 0;
				break;
			case GUI_MENU_NOUVELLE_PARTIE_RESEAU:
				FlagModeDuJeu = MODE_VSRESEAU;
				Flag_NumeroDuMenuAAfficher = gui_menu_principal;
				Flag_Draw_Menu = 0;
				break;
			
			case GUI_MENU_QUITTER_OK:
				SDL_Quit();
				break;
			case GUI_MENU_QUITTER_ANNULER:
				Flag_NumeroDuMenuAAfficher = gui_menu_principal;
				break;

			case GUI_INFO_PASSETOUR_OK:
				Flag_Draw_Info = 0;
				break;
			case GUI_INFO_FINDUJEU_OK:
				Flag_Draw_Info = 0;
				break;
		}
	}
		
}

void CEvent::MouseMotion(int mousex, int mousey, CGame *Event_Game)
{

    if((Flag_Draw_Menu == 0) && (Flag_Draw_Info == 0))
    {
    
      if(tmpupdown == 1)
      {
    
          board_rotate_y -= (float)( ( (float)oldmousex - (float)mousex ) / 4 );
          board_rotate_x -= (float)( ( (float)oldmousey - (float)mousey ) / 4 );

      }
      
      SDL_GetMouseState(&oldmousex, &oldmousey);
      
    }
  
}

CEvent::~CEvent()
{

}
