// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// 
// FAUVART Sbastien	<seb.fauvart@free.fr>
// Mon May 19 12:57:45 2003


#include "../include/game.h"

int FlagModeDuJeu;

CGame::CGame()
{
    InitGame();
}

void CGame::InitGame()
{
   int i, j;
   
    // efface tout le plateau

    for( i=0; i<8; i++ )
    {
      for( j=0; j<8; j++ )
      {
        gameboard[i][j] = 0;
      }
    }

    // initialise le plateau

    gameboard[3][4] = PLAYER_1;
    gameboard[4][3] = PLAYER_1;
    gameboard[3][3] = PLAYER_2;
    gameboard[4][4] = PLAYER_2;

    // initialise les scores

    score_player1 = 2;
    score_player2 = 2;

    aquiletour = PLAYER_1;

}

int CGame::XY_to_Case(int x, int y)
{

   return (0x200 + (y<<4) + x);

}

int CGame::Case_to_X(int number)
{

   return (number & 0xF);

}

int CGame::Case_to_Y(int number)
{

   return ( (number >> 4) & 0xF );

}

int CGame::Game_testmove(int x, int y, int side, int dx, int dy, int execute)
{
    int i, ox, oy, found_end;

    i = found_end = 0;

    ox = x;   oy = y;
    x += dx;  y += dy;

    while((x>=0) && (x<8) && (y>=0) && (y<8) && (found_end==0))
    {
      if(gameboard[x][y] == side)
        found_end = 1;
      else if(gameboard[x][y] == 0)
        break;
      else
        i++;

      x+=dx;  y+=dy;

    }

    if(found_end == 1)
    {
      if(execute == 1)
      {
        while((x != ox) || (y != oy))
        {
            x -= dx;
            y -= dy;
            gameboard[x][y] = side;
        }
      }
     return i;
    }
    
  return 0;

}

int CGame::Game_validmove(int case_number, int side, int execute)
{
    int x, y, i, capture;

    capture = i = 0;

    x = Case_to_X(case_number);
    y = Case_to_Y(case_number);

  int opp;
  int pieces = 0;

  if(side == 1) opp = 2;
  if(side == 2) opp = 1;

  if(gameboard[x][y] == 0)
  {
    if(x>0)
    {
      if(y>0)
        if(gameboard[x-1][y-1] == opp)
          pieces += Game_testmove(x, y, side, -1, -1, execute);

      if(gameboard[x-1][y] == opp)
        pieces += Game_testmove(x, y, side, -1, 0, execute);

      if(y<7)
        if(gameboard[x-1][y+1] == opp)
          pieces += Game_testmove(x, y, side, -1, 1, execute);
    }

    if(y>0)
      if(gameboard[x][y-1] == opp)
        pieces += Game_testmove(x, y, side, 0, -1, execute);

    if(y<7)
      if(gameboard[x][y+1] == opp)
        pieces += Game_testmove(x, y, side, 0, 1, execute);

    if(x<7)
    {
      if(y>0)
        if(gameboard[x+1][y-1] == opp)
          pieces += Game_testmove(x, y, side, 1, -1, execute);

      if(gameboard[x+1][y] == opp)
        pieces += Game_testmove(x, y, side, 1, 0, execute);

      if(y<7)
        if(gameboard[x+1][y+1] == opp)
          pieces += Game_testmove(x, y, side, 1, 1, execute);
    }

   }

    return pieces;
}

void CGame::Game_validallmove(int side)
{
/*  int i, j, XY;

    for(i=0;i<8;i++)
    {
      
      for(j=0;j<8;j++)
      {
        
         XY = XY_to_Case ( i, j);
         valid_all_move[XY] = Game_validmove(XY, side, 0);
         
      }
      
    } */

}

void CGame::Game_calculate_score()
{
  int i, j;

  score_player1 = score_player2 = 0;

    for(i=0;i<8;i++)
    {
      for(j=0;j<8;j++)
      {
        if(gameboard[i][j] == PLAYER_1)
          score_player1++;

        if(gameboard[i][j] == PLAYER_2)
          score_player2++;
      }
    }

}

void CGame::Game_cpu_play()
{
/*  int tmp_capture, tmp_capture1, i, j, tmp_case, tmp_case1, done = 0;
  int opp, tmp_casemax, tmp_casemin, tmp_min = 100, tmp_max = 0;
  int calc_min;
  //int compteur = 0;
  board calc_board;

  if(difficulte == 1)
  {

    for(i=0;i<8;i++)
    {
      for(j=0;j<8;j++)
      {
        if(done == 0)
        {
          tmp_case = XY_to_Case ( i, j);
          tmp_capture = Game_validmove(tmp_case, aquiletour, bo, 0);

          if(tmp_capture > 0)
          {
            Game_validmove(tmp_case, aquiletour, bo, 1);
            done++;
          }
        }
      }
    }

  }

  if(difficulte == 2)
  {

    for(i=0;i<8;i++)
    {
      for(j=0;j<8;j++)
      {
          tmp_case = XY_to_Case ( i, j);
          tmp_capture = Game_validmove(tmp_case, aquiletour, bo, 0);

          if(tmp_capture > tmp_max)
          {
            tmp_max = tmp_capture;
            tmp_casemax = tmp_case;
          }
      }
    }

    Game_validmove(tmp_casemax, aquiletour, bo, 1);
    done++;

  }

  if(difficulte == 3)
  {
    if(aquiletour == 1)
      opp = 2;
    else
      opp = 1;

    for(i=0;i<8;i++)
    {
      for(j=0;j<8;j++)
      {
        for(int Y=0;Y<8;Y++)
        {
          for(int X=0;X<8;X++)
          {
            calc_board[X][Y] = bo[X][Y];
          }
        }

        tmp_case = XY_to_Case ( i, j);
        tmp_capture = Game_validmove(tmp_case, aquiletour, calc_board, 0);

        if(tmp_capture > 0)
        {
          Game_validmove(tmp_case, aquiletour, calc_board, 1);

          for(int k=0;k<8;k++)
          {
            for(int l=0;l<8;l++)
            {
              tmp_case1 = XY_to_Case ( k, l);
              calc_min += Game_validmove(tmp_case1, opp, calc_board, 0);
            }
          }

        }
        else
          calc_min = 0;

        if( calc_min > 0 )
        {
          if( calc_min < tmp_min )
          {
            tmp_min = calc_min;
            tmp_casemin = tmp_case;
          }
        }

        //compteur++;
      }
    }

    Game_validmove(tmp_casemin, aquiletour, bo, 1);
    done++;

  }


  if(done == 0)
    passe_son_tour = 1;
  else
  {
      if(aquiletour == 1)
        aquiletour = 2;
      else
        aquiletour = 1;
  }       */

}

int CGame::Game_peut_jouer()
{
/*  int tmp_capture = 0, i, j, tmp_case, done = 0;

    for(i=0;i<8;i++)
    {
      for(j=0;j<8;j++)
      {
          tmp_case = XY_to_Case ( i, j);
          tmp_capture += Game_validmove(tmp_case, aquiletour, bo, 0);
      }
    }

  if(tmp_capture == 0)
    return 1;
  else
    return 0;
              */
	return 0;
}

int CGame::Game_is_the_end()
{
/*  int tmp_capture = 0, i, j, tmp_case, done = 0;

    for(i=0;i<8;i++)
    {
      for(j=0;j<8;j++)
      {
          tmp_case = XY_to_Case ( i, j);
          tmp_capture += Game_validmove(tmp_case, 1, bo, 0);
          tmp_capture += Game_validmove(tmp_case, 2, bo, 0);
      }
    }

 if(tmp_capture > 0)
   return 0;
 else
   return 1;     */

	return 0;
}

CGame::~CGame()
{

}
